connectorEntity={}
railEntity={}
trainEntity={}
electricPoleEntity={}
EventsControl[prototypeConnector]=connectorEntity
EventsControl[railPoleConnector]=connectorEntity
EventsControl["straight-rail"]=railEntity
EventsControl["curved-rail"]=railEntity
EventsControl["locomotive"]=trainEntity
EventsControl["electric-pole"]=electricPoleEntity
electricPoleEntity.allowType=true
connectorEntity.allowType=true
railEntity.allowType=true
trainEntity.allowType=true

listConnectionsToClean={}

function OnTick()
	for _,railProto in pairs(listConnectionsToClean) do
		railProto:cleanConnections()
	end
	listConnectionsToClean={}
	for _,data in pairs(listTrains) do
		data:update()
	end
end

connectorEntity.OnBuilt=function(entity)	
	RailPoleConnectorPrototype:new(entity):connectToRail()
end

connectorEntity.OnRemoved=function(entity)	
	if listRailPoleConnectors[entity.unit_number] then
		local connectedRail=listRailPoleConnectors[entity.unit_number]:remove()
	if connectedRail then
		table.insert(listConnectionsToClean,connectedRail)
		end
	end
end

electricPoleEntity.OnBuilt=function(entity)	
	if entity.name==prototypeConnector then
		return
	end
	for _,neighbour_entities in pairs(entity.neighbours) do
		for _,neighbour_entity in pairs(neighbour_entities) do
			if neighbour_entity.name==circuitNode then
				entity.disconnect_neighbour(neighbour_entity)
				entity.disconnect_neighbour{wire=defines.wire_type.red, target_entity=neighbour_entity}
				entity.disconnect_neighbour{wire=defines.wire_type.green, target_entity=neighbour_entity}
			end
		end
	end
end


railEntity.OnBuilt=function(entity)
	if railType[entity.name] then
		local rail=RailPrototype:new(entity)
		rail:connectToOtherRails()	
		rail:connectToRailPoleConnector()
	end
end

railEntity.OnRemoved=function(entity)
	if listRails[entity.unit_number] then
		listRails[entity.unit_number]:remove()
	end
end

OnTrainCreated=function(event)
	if event.old_train_id_1 then listTrains[event.old_train_id_1]=nil end
	if event.old_train_id_2 then listTrains[event.old_train_id_2]=nil end
	for _,loco in pairs(event.train.locomotives.front_movers) do
		if locomotiveType[loco.name] then
			TrainPrototype:new(event.train)	
			return
		end
	end
	for _,loco in pairs(event.train.locomotives.back_movers) do
		if locomotiveType[loco.name] then
			TrainPrototype:new(event.train)	
			return
		end
	end
end

trainEntity.OnRemoved=function(entity)
	listTrains[entity.train.id]=nil
end