RailPrototype={}
railType={}
railType[electricStraightRail]="straight"
railType[electricCurvedRail]="curved"

function RailPrototype:new(entity)
	if entity.valid==false then
		return
	end
	
	local railNode=game.surfaces[1].create_entity{name=circuitNode,position=entity.position,force=entity.force}
	railNode.disconnect_neighbour()
	railNode.operable=false
	railNode.minable=false
	railNode.destructible=false
	local accu = game.surfaces[1].create_entity
		{
			name=railElectricAccu,
			position=railNode.position,
			force=entity.force
		}
	accu.operable = false
	accu.minable = false
	accu.destructible = false
	local o=
	{
		globalData=
		{
			entity=entity, 
			accu=accu,
			railNode=railNode
		}
	}   
    setmetatable(o, self)
	listRails[entity.unit_number]=o
	global.listRails[entity.unit_number]=o.globalData
    return o
end

function RailPrototype:remove()
	listRails[self.globalData.entity.unit_number]=nil
	global.listRails[self.globalData.entity.unit_number]=nil
	local railPoleConnected
	local connectedNodes={}	
	for _,neighbourTable in pairs(self.globalData.railNode.neighbours) do		
		for _,neighbour_entity in pairs(neighbourTable)do					
			table.insert(connectedNodes, neighbour_entity)
		end
	end		
	self.globalData.accu.destroy()	
	self.globalData.railNode.destroy()		
	for i=1,#connectedNodes-1 do
		for j=i+1,#connectedNodes do
			disconnectAllWires(connectedNodes[i],connectedNodes[j])
		end
	end
end

function RailPrototype:connectToOtherRails()
	local connectedRails={}
	for _,rail_direction in pairs(defines.rail_direction) do
		for _,rail_connection_direction in pairs(defines.rail_connection_direction) do
			if rail_connection_direction~=3 then
				local connectedRail= self.globalData.entity.get_connected_rail{rail_direction=rail_direction,rail_connection_direction=rail_connection_direction}
				if connectedRail and listRails[connectedRail.unit_number] then
					connectAllWires(self.globalData.railNode,listRails[connectedRail.unit_number].globalData.railNode)
				end
			end
		end
	end
end

function RailPrototype:connectToRailPoleConnector()
	local x=self.globalData.entity.position.x
	local y=self.globalData.entity.position.y
	for _,railPole in pairs(game.surfaces[1].find_entities_filtered{area = {{x-2,y-2},{x+2,y+2}}, name=railPoleConnector}) do
		if listRailPoleConnectors[railPole.unit_number] then
			listRailPoleConnectors[railPole.unit_number].globalData.rail=self
			listRailPoleConnectors[railPole.unit_number]:connectToRail()
		end
	end
end

function RailPrototype:cleanConnections()
	local railNode = self.globalData.railNode
	if not railNode or not railNode.valid then
		return
	end
	for _,neighbourTable in pairs(railNode.neighbours) do
		for _,neighbour_entity in pairs(neighbourTable)do					
			if neighbour_entity.name~=circuitNode and neighbour_entity.name~=railPoleConnector then					
				railNode.disconnect_neighbour(neighbour_entity)
				railNode.disconnect_neighbour{wire=defines.wire_type.red, target_entity=neighbour_entity}
				railNode.disconnect_neighbour{wire=defines.wire_type.green, target_entity=neighbour_entity}
			end
		end
	end		
end